//** Linking:
//** Blinker fi folder LIB llibg, clipper

//** Include files
#include "inkey.ch"
#include "llibg.ch"

//** Declare static arrays
STATIC arArray := {}
//                                                                                
//  Structure for arArray:                                                         
//  You will need 8 set of coordinates of which #1, #6, #7 and #8 will be
//  the same for all tabs         
//
//  Tab 1:
//    3 Ŀ 4
//  1+2 - - - - - - -Ŀ 6
//                   5                   
//                                       
//                                       
//    8  7
//
//  Tab 2:                    
//                  3 Ŀ4
//    1 - - - - - - Ŀ 6
//                   2            5      
//                                       
//                                       
//    8  7
//
//
//  Element no. 1:  Upper left corner           - same for all tabs
//  Element no. 2:  Lower left corner on tab                          
//  Element no. 3:  Upper left corner on tab                           
//  Element no. 4:  Upper right corner on tab                             
//  Element no. 5:  Lower right corner on tab                            
//  Element no. 6:  Upper right corner          - same for all tabs
//  Element no. 7:  Lower right corner          - same for all tabs
//  Element no. 8:  Lover left corner           - same for all tabs
//                                                                                
//  REMEMBER!!      Horisontal coordinate first, second vertical               
//                                                                                
STATIC arNames  := {}
STATIC arBmp    := {}

Procedure Main()
    LOCAL cTab01
    LOCAL cTab02
    LOCAL lOk           := .T.
    LOCAL nKey
    LOCAL aState        := {}
    LOCAL n
    LOCAL n1            := 0
    LOCAL aFont
    LOCAL nFocus
    LOCAL nOldCursor    := SetCursor( 0 )
    Scroll()
    If !MPRESENT()
        @ 10, 10 Say "You must have a mouse connected to run this programme!"
        @ 11, 21 Say "Hitting any key will terminate"
        Inkey( 0 )
        SetCursor( nOldCursor )
        Quit
    Endif
    SET VIDEOMODE To LLG_VIDEO_VGA_640_480_16
    SET EVENTMASK To INKEY_ALL
    MShow()
    aFont := GFNTLOAD( "Currier.fnd" )
    Aadd( arNames, { "Test1", 0, "First test" } )
    Aadd( arNames, { "Test2", 0, "Second test" } )
    Aadd( arNames, { "Test3", 0, "Third test" } )
    Aadd( arNames, { "Test4", 0, "Fourth test" } )
    Aadd( arBmp, GBMPLOAD( "Hand.Bmp" ) )
    Aadd( arBmp, GBMPLOAD( "Lion.Bmp" ) )
    Aadd( arBmp, GBMPLOAD( "NovLogo1.Bmp" ) )
    Aadd( arBmp, GBMPLOAD( "Frog.Bmp" ) )
    DrawFolder( 4, 40, 600, 50, 600, 40, 400, aFont )   // See below for details about parameters
    nFocus := 1
    While nKey != K_ESC
        nKey := Inkey()
        aState := MState()
        DO CASE
        CASE nKey == 1002
            For n := 1 To Len( arArray )
                If aState[ LLM_STATE_X ] >= arArray[n][2,1] .AND. aState[ LLM_STATE_X ] <= arArray[n][5,1]
                    If aState[ LLM_STATE_Y ] <= arArray[n][2,2] .AND. aState[ LLM_STATE_Y ] >= arArray[n][3,2]
                        nFocus := n
                        ReDraw( n, aFont )
                    Endif
                Endif
            Next
        OTHERWISE
            For n := 1 To Len( arArray )
                If aState[ LLM_STATE_X ] >= arArray[n][2,1] .AND. aState[ LLM_STATE_X ] <= arArray[n][5,1]
                    If aState[ LLM_STATE_Y ] <= arArray[n][2,2] .AND. aState[ LLM_STATE_Y ] >= arArray[n][3,2]
                        While n != n1
                            n1 := n
                            ShowText( n, aFont, aState, @nFocus )
                            nKey := Inkey()
                        Enddo
                    Endif
                Endif
            Next
        ENDCASE
    Enddo
    GFNTERASE( aFont )
    SET VIDEOMODE To LLG_VIDEO_TXT
    SetCursor( nOldCursor )
Return

Function DrawFolder( nAntal, nTopLeft, nTopRight, nTopRow, nBotRight, nBotLeft, nBotRow, aFont )
/*
    Parameters:
        nAntal .........:   Integer, number of tabs to create
        nTopLeft .......:   Integer in pixels, left border of folder
        nTopRight ......:   Integer in pixels, right border of folder
        nTopRow ........:   Integer in pixels, top border of folder
        nBotRight ......:   Equal to nTopRight
        nBotLeft .......:   Equal to nTopLeft
        nBotRow ........:   Integer in pixels, bottom border of folder
        aFont ..........:   Font to be used
*/
    LOCAL nTabTop
    LOCAL nTabLeft
    LOCAL nTabRight
    LOCAL nTabLength
    LOCAL nNumber
    LOCAL nWidth
    LOCAL nXPos
    LOCAL nYPos
    nTabLength  := ( ( nTopRight - nTopLeft ) / nAntal )
    nTabLeft    := nTopLeft
    nTabTop     := nTopRow - 25
    For nNumber := 1 To nAntal
        Aadd( arArray, { { nTopLeft, nTopRow },                             ; // Upper left corner        
                         { nTabLeft, nTopRow },                             ; // Lower left corner on tab 
                         { nTabLeft + 25, nTabTop },                        ; // Upper left corner on tab
                         { nTabLeft + nTabLength - 25, nTabTop },           ; // Upper right corner on tab
                         { nTopLeft + ( nNumber * nTabLength ), nTopRow },  ; // Lower right corner on tab
                         { nTopRight, nTopRow },                            ; // Upper right corner
                         { nBotRight, nBotRow },                            ; // Lower right corner
                         { nBotLeft, nBotRow } } )                            // Lower left corner
        nTabLeft := nTabLeft + nTabLength
    Next
    For nNumber := nAntal to 1 Step -1
        GPOLYGON( arArray[nNumber], LLG_FILL, LLG_MODE_XOR, 8, 15 )
        GWRITEAT( nTopRight - nTabLength + ( ( nNumber - nAntal ) * nTabLength ) + 25, nTopRow - 15, arNames[nNumber,1], 10, LLG_MODE_SET, aFont )
        nWidth := GWRITEAT( 800, 800, arNames[nNumber,3], 10, LLG_MODE_SET, aFont )
        arNames[nNumber,2] := nWidth
        nXPos := arBmp[nNumber][ LLG_BMP_X ]
        nYPos := arBmp[nNumber][ LLG_BMP_Y ]
        CenterBmp( @nXPos, @nYPos )
        GBMPDISP( arBmp[nNumber], nXPos, nYPos )
    Next
Return .T.

Function Redraw( nNumber, aFont )
    LOCAL nTabLength
    LOCAL nTopRight := arArray[nNumber][6,1]
    LOCAL nTopLeft  := arArray[nNumber][1,1]
    LOCAL nTopRow   := arArray[nNumber][1,2]
    LOCAL nXPos
    LOCAL nYPos
    nTabLength  := ( ( nTopRight - nTopLeft ) / Len( arArray ) )
    GPOLYGON( arArray[nNumber], LLG_FILL, LLG_MODE_XOR, 8, 15 )
    GWRITEAT( nTopLeft + ( ( nNumber - 1 ) * nTabLength ) + 25, nTopRow - 15, arNames[nNumber,1], 10, LLG_MODE_SET, aFont )
    nXPos := arBmp[nNumber][ LLG_BMP_X ]
    nYPos := arBmp[nNumber][ LLG_BMP_Y ]
    CenterBmp( @nXPos, @nYPos )
    GBMPDISP( arBmp[nNumber], nXPos, nYPos )
Return .T.

Function ShowText( nNumber, aFont, aState, nFocus )
    LOCAL aState1 := {}
    LOCAL nKey
    LOCAL nExitKey := 0
    aState1 := MState()
    GRECT( aState[ LLM_STATE_X ] +25, aState[ LLM_STATE_Y ], aState[ LLM_STATE_X ] +25 + arNames[nNumber,2], aState[ LLM_STATE_Y ] + 25, LLG_FILL, 14, LLG_MODE_XOR )
    GWRITEAT( aState[ LLM_STATE_X ] + 25, aState[ LLM_STATE_Y ]+5, arNames[nNumber,3], 8, LLG_MODE_XOR, aFont )
    While aState1[ LLM_STATE_X ] >= arArray[nNumber][2,1] .AND. aState1[ LLM_STATE_X ] <= arArray[nNumber][5,1] ;
        .AND. aState1[ LLM_STATE_Y ] <= arArray[nNumber][2,2] .AND. aState1[ LLM_STATE_Y ] >= arArray[nNumber][3,2]
        aState1 := MState()
        nKey := Inkey()
        If nKey == 1002
            GRECT( aState[ LLM_STATE_X ] + 25, aState[ LLM_STATE_Y ], aState[ LLM_STATE_X ] + 25 + arNames[nNumber,2], aState[ LLM_STATE_Y ] + 25, LLG_FILL, 14, LLG_MODE_XOR )
            GWRITEAT( aState[ LLM_STATE_X ] + 25, aState[ LLM_STATE_Y ]+5, arNames[nNumber,3], 8, LLG_MODE_XOR, aFont )
            ReDraw( nNumber, aFont )
            nExitKey := nKey
            nFocus := nNumber
        Endif
    Enddo
    If nExitKey == 1002
        ReDraw( nNumber, aFont )
    Else
        GRECT( aState[ LLM_STATE_X ] + 25, aState[ LLM_STATE_Y ], aState[ LLM_STATE_X ] + 25 + arNames[nNumber,2], aState[ LLM_STATE_Y ] + 25, LLG_FILL, 14, LLG_MODE_XOR )
        GWRITEAT( aState[ LLM_STATE_X ] + 25, aState[ LLM_STATE_Y ]+5, arNames[nNumber,3], 8, LLG_MODE_XOR, aFont )
        ReDraw( nFocus, aFont )
    Endif
Return nFocus

STATIC Function CenterBmp( x, y )
    LOCAL aGMode := GMODE()
    x := Int( ( aGMode[ LLG_MODE_GRAPH_COL ] - x ) / 2 )
    y := Int( ( aGMode[ LLG_MODE_GRAPH_ROW ] - y ) / 2 )
Return NIL

